<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Accessories: D:/Mes documents/Trusty/Arduino/Libraries/Accessories/src/LocoStepper.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Accessories
   </div>
   <div id="projectbrief">Arduino for motors and lights library.</div>
  </td>
   <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('LocoStepper_8cpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">LocoStepper.cpp</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="Accessories_8h.html">Accessories.h</a>&quot;</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;</div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef NO_STEPPER</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="LocoStepper_8h.html">LocoStepper.h</a>&quot;</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;uint8_t step2default[4] =</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;{</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;    B01,</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;    B11,</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;    B10,</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;    B00,</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;};</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;uint8_t step4default[4] =</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;{</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    B1010,</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    B0110,</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    B0101,</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    B1001,</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;};</div><div class="line"><a name="l00021"></a><span class="lineno"><a class="line" href="classLocoStepper.html#abefb91b8c07a88e6f5026e0805acdf74">   21</a></span>&#160;<a class="code" href="classLocoStepper.html#abefb91b8c07a88e6f5026e0805acdf74">LocoStepper::LocoStepper</a>(uint8_t pin1, uint8_t pin2, uint8_t *pStep2) : <a class="code" href="classLocoStepper.html">LocoStepper</a>(pin1, pin2, 255, 255)</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;{</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keywordflow">if</span> (pStep2 == NULL)</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        this-&gt;pSteps = step2default;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;        this-&gt;pSteps = pStep2;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;}</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="classLocoStepper.html#aa4a6ac8d2b1eefbe562e09b4762e4bd0">   29</a></span>&#160;<a class="code" href="classLocoStepper.html#abefb91b8c07a88e6f5026e0805acdf74">LocoStepper::LocoStepper</a>(uint8_t pin1, uint8_t pin2, uint8_t pin3, uint8_t pin4, uint8_t *pStep4)</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;{</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    _currentPos = 0;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    _targetPos = 0;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    _speed = 0.0;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    _stepInterval = 0;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    _lastRunTime = 0;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    _minPulseWidth = 1;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    _lastStepTime = 0;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    _pin1 = pin1;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    _pin2 = pin2;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    _pin3 = pin3;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    _pin4 = pin4;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="keywordflow">if</span> (pStep4 == NULL)</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        this-&gt;pSteps = step4default;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        this-&gt;pSteps = pStep4;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <a class="code" href="classLocoStepper.html#a10a8e0c2464a99df13ff50f675e7b4e0">enableOutputs</a>();</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;}</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div><div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="classLocoStepper.html#ae0792a7479f1a52018d948c22600fab0">   49</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classLocoStepper.html#ae0792a7479f1a52018d948c22600fab0">LocoStepper::moveTo</a>(<span class="keywordtype">long</span> absolute)</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;{</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    _targetPos = absolute;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keywordtype">long</span> distanceTo = <a class="code" href="classLocoStepper.html#a2716957fdca4c048fcf5ba65e89abc95">distanceToGo</a>();</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keywordflow">if</span> (distanceTo == 0)</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        <a class="code" href="classLocoStepper.html#ae5c23466938595842934a2331cfeb21e">setSpeed</a>(0.0f); <span class="comment">// We&#39;re there</span></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keywordflow">if</span> (distanceTo &gt; 0) <span class="comment">// Clockwise</span></div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <a class="code" href="classLocoStepper.html#ae5c23466938595842934a2331cfeb21e">setSpeed</a>((<span class="keywordtype">float</span>) fabs(_speed));</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        <a class="code" href="classLocoStepper.html#ae5c23466938595842934a2331cfeb21e">setSpeed</a>((<span class="keywordtype">float</span>) -fabs(_speed));</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;}</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div><div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="classLocoStepper.html#a8be0715eaa122dc111359e9dd06168d9">   63</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classLocoStepper.html#a8be0715eaa122dc111359e9dd06168d9">LocoStepper::move</a>(<span class="keywordtype">long</span> relative)</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;{</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <a class="code" href="classLocoStepper.html#ae0792a7479f1a52018d948c22600fab0">moveTo</a>(_currentPos + relative);</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;}</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="comment">// Run the motor to implement speed and acceleration in order to proceed to the target position</span></div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="comment">// You must call this at least once per step, preferably in your main loop</span></div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<span class="comment">// If the motor is in the desired position, the cost is very small</span></div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="comment">// returns true if we are still running to position</span></div><div class="line"><a name="l00072"></a><span class="lineno"><a class="line" href="classLocoStepper.html#ae4045493f8395d7b3dc0a8e1477b3596">   72</a></span>&#160;<span class="keywordtype">boolean</span> <a class="code" href="classLocoStepper.html#ae4045493f8395d7b3dc0a8e1477b3596">LocoStepper::run</a>()</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;{</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keywordflow">if</span> (_targetPos == _currentPos)</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> time = micros();</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="keywordflow">if</span> ((time &gt;= (_lastStepTime + _stepInterval))  <span class="comment">// okay if both current time and next step time wrap</span></div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        || ((time &lt; _lastRunTime) &amp;&amp; (time &gt;(0xFFFFFFFF - (_lastStepTime + _stepInterval)))))  <span class="comment">// check if only current time has wrapped</span></div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    {</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        <span class="keywordflow">if</span> (_speed &gt; 0.0f)</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        {</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;            <span class="comment">// Clockwise</span></div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;            _currentPos += 1;</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        }</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        <span class="keywordflow">else</span> </div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;            <span class="keywordflow">if</span> (_speed &lt; 0.0f)</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;            {</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;                <span class="comment">// Anticlockwise  </span></div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;                _currentPos -= 1;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;            }</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        <span class="keywordflow">if</span> (this-&gt;_pin3 == 255)</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;            <a class="code" href="classLocoStepper.html#a819e566cc3c4586f5a2c095983fa52f3">step2</a>(_currentPos &amp; 0x3); <span class="comment">// Bottom 2 bits (same as mod 4, but works with + and - numbers) </span></div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        <span class="keywordflow">else</span></div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;            <a class="code" href="classLocoStepper.html#a3b2f0bee97af34b780e8d715eedf7b4d">step4</a>(_currentPos &amp; 0x3); <span class="comment">// Bottom 2 bits (same as mod 4, but works with + and - numbers) </span></div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        _lastRunTime = time;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        _lastStepTime = time;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    }</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        _lastRunTime = time;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;}</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno"><a class="line" href="classLocoStepper.html#a2716957fdca4c048fcf5ba65e89abc95">  108</a></span>&#160;<span class="keywordtype">long</span> <a class="code" href="classLocoStepper.html#a2716957fdca4c048fcf5ba65e89abc95">LocoStepper::distanceToGo</a>()</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;{</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <span class="keywordflow">return</span> _targetPos - _currentPos;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;}</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno"><a class="line" href="classLocoStepper.html#a92a8648eb49926cdb11f96cdc6de17b4">  113</a></span>&#160;<span class="keywordtype">long</span> <a class="code" href="classLocoStepper.html#a92a8648eb49926cdb11f96cdc6de17b4">LocoStepper::targetPosition</a>()</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;{</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    <span class="keywordflow">return</span> _targetPos;</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;}</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;</div><div class="line"><a name="l00118"></a><span class="lineno"><a class="line" href="classLocoStepper.html#a3f619bbe60bc7f71b64d0447b7c6b0ad">  118</a></span>&#160;<span class="keywordtype">long</span> <a class="code" href="classLocoStepper.html#a3f619bbe60bc7f71b64d0447b7c6b0ad">LocoStepper::currentPosition</a>()</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;{</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <span class="keywordflow">return</span> _currentPos;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;}</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;<span class="comment">// Useful during initialisations or after initial positioning</span></div><div class="line"><a name="l00124"></a><span class="lineno"><a class="line" href="classLocoStepper.html#a0ff4c5df6aa76c31d05c357f48bf1223">  124</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classLocoStepper.html#a0ff4c5df6aa76c31d05c357f48bf1223">LocoStepper::setCurrentPosition</a>(<span class="keywordtype">long</span> position)</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;{</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    _currentPos = position;</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;}</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;</div><div class="line"><a name="l00129"></a><span class="lineno"><a class="line" href="classLocoStepper.html#ae5c23466938595842934a2331cfeb21e">  129</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classLocoStepper.html#ae5c23466938595842934a2331cfeb21e">LocoStepper::setSpeed</a>(<span class="keywordtype">float</span> speed)</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;{</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    _speed = <a class="code" href="classLocoStepper.html#a75ea615634b59ab0880cad22f7b40c48">speed</a>;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    _stepInterval = (<span class="keywordtype">unsigned</span> long) fabs(1000000.0 / _speed);</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;}</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;</div><div class="line"><a name="l00135"></a><span class="lineno"><a class="line" href="classLocoStepper.html#a75ea615634b59ab0880cad22f7b40c48">  135</a></span>&#160;<span class="keywordtype">float</span> <a class="code" href="classLocoStepper.html#a75ea615634b59ab0880cad22f7b40c48">LocoStepper::speed</a>()</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;{</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    <span class="keywordflow">return</span> _speed;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;}</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;<span class="comment">// 2 pin step function</span></div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;<span class="comment">// This is passed the current step number (0 to 3)</span></div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;<span class="comment">// Subclasses can override</span></div><div class="line"><a name="l00143"></a><span class="lineno"><a class="line" href="classLocoStepper.html#a819e566cc3c4586f5a2c095983fa52f3">  143</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classLocoStepper.html#a819e566cc3c4586f5a2c095983fa52f3">LocoStepper::step2</a>(uint8_t step)</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;{</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    <span class="keywordflow">if</span> ((this-&gt;pSteps[step] &amp; B10) &gt; 0)</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        digitalWrite(_pin1, HIGH);</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        digitalWrite(_pin1, LOW);</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        </div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    <span class="keywordflow">if</span> ((this-&gt;pSteps[step] &amp; B01) &gt; 0)</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        digitalWrite(_pin2, HIGH);</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        digitalWrite(_pin2, LOW);</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;}</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;<span class="comment">// 4 pin step function</span></div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;<span class="comment">// This is passed the current step number (0 to 3)</span></div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;<span class="comment">// Subclasses can override</span></div><div class="line"><a name="l00159"></a><span class="lineno"><a class="line" href="classLocoStepper.html#a3b2f0bee97af34b780e8d715eedf7b4d">  159</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classLocoStepper.html#a3b2f0bee97af34b780e8d715eedf7b4d">LocoStepper::step4</a>(uint8_t step)</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;{</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    <span class="keywordflow">if</span> ((this-&gt;pSteps[step] &amp; B1000) &gt; 0)</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;        digitalWrite(_pin1, HIGH);</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        digitalWrite(_pin2, LOW);</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;    <span class="keywordflow">if</span> ((this-&gt;pSteps[step] &amp; B0100) &gt; 0)</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;        digitalWrite(_pin2, HIGH);</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;        digitalWrite(_pin3, LOW);</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;    <span class="keywordflow">if</span> ((this-&gt;pSteps[step] &amp; B0010) &gt; 0)</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        digitalWrite(_pin3, HIGH);</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        digitalWrite(_pin4, LOW);</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <span class="keywordflow">if</span> ((this-&gt;pSteps[step] &amp; B0001) &gt; 0)</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        digitalWrite(_pin4, HIGH);</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        digitalWrite(_pin1, LOW);</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;}</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;<span class="comment">// Prevents power consumption on the outputs</span></div><div class="line"><a name="l00181"></a><span class="lineno"><a class="line" href="classLocoStepper.html#a66ed72e5f551d8ffe86b00e642c832f2">  181</a></span>&#160;<span class="keywordtype">void</span>    <a class="code" href="classLocoStepper.html#a66ed72e5f551d8ffe86b00e642c832f2">LocoStepper::disableOutputs</a>()</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;{   </div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    digitalWrite(_pin1, LOW);</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    digitalWrite(_pin2, LOW);</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    <span class="keywordflow">if</span> (_pin3 != 255)</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;       digitalWrite(_pin3, LOW);</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    <span class="keywordflow">if</span> (_pin4 != 255)</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;       digitalWrite(_pin4, LOW);</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;}</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;</div><div class="line"><a name="l00191"></a><span class="lineno"><a class="line" href="classLocoStepper.html#a10a8e0c2464a99df13ff50f675e7b4e0">  191</a></span>&#160;<span class="keywordtype">void</span>    <a class="code" href="classLocoStepper.html#a10a8e0c2464a99df13ff50f675e7b4e0">LocoStepper::enableOutputs</a>()</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;{</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;    pinMode(_pin1, OUTPUT);</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    pinMode(_pin2, OUTPUT);</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    <span class="keywordflow">if</span> (_pin3 != 255)</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;        pinMode(_pin3, OUTPUT);</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    <span class="keywordflow">if</span> (_pin4 != 255)</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;       pinMode(_pin4, OUTPUT);</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;}</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;</div><div class="line"><a name="l00201"></a><span class="lineno"><a class="line" href="classLocoStepper.html#ad542ef50f02428220ab20af161e5a541">  201</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classLocoStepper.html#ad542ef50f02428220ab20af161e5a541">LocoStepper::setMinPulseWidth</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> minWidth)</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;{</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;  _minPulseWidth = minWidth;</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;}</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="classLocoStepper_html_a66ed72e5f551d8ffe86b00e642c832f2"><div class="ttname"><a href="classLocoStepper.html#a66ed72e5f551d8ffe86b00e642c832f2">LocoStepper::disableOutputs</a></div><div class="ttdeci">void disableOutputs()</div><div class="ttdef"><b>Definition:</b> <a href="LocoStepper_8cpp_source.html#l00181">LocoStepper.cpp:181</a></div></div>
<div class="ttc" id="classLocoStepper_html_a0ff4c5df6aa76c31d05c357f48bf1223"><div class="ttname"><a href="classLocoStepper.html#a0ff4c5df6aa76c31d05c357f48bf1223">LocoStepper::setCurrentPosition</a></div><div class="ttdeci">void setCurrentPosition(long position)</div><div class="ttdef"><b>Definition:</b> <a href="LocoStepper_8cpp_source.html#l00124">LocoStepper.cpp:124</a></div></div>
<div class="ttc" id="classLocoStepper_html_a3f619bbe60bc7f71b64d0447b7c6b0ad"><div class="ttname"><a href="classLocoStepper.html#a3f619bbe60bc7f71b64d0447b7c6b0ad">LocoStepper::currentPosition</a></div><div class="ttdeci">long currentPosition()</div><div class="ttdef"><b>Definition:</b> <a href="LocoStepper_8cpp_source.html#l00118">LocoStepper.cpp:118</a></div></div>
<div class="ttc" id="classLocoStepper_html_a3b2f0bee97af34b780e8d715eedf7b4d"><div class="ttname"><a href="classLocoStepper.html#a3b2f0bee97af34b780e8d715eedf7b4d">LocoStepper::step4</a></div><div class="ttdeci">void step4(uint8_t step)</div><div class="ttdef"><b>Definition:</b> <a href="LocoStepper_8cpp_source.html#l00159">LocoStepper.cpp:159</a></div></div>
<div class="ttc" id="classLocoStepper_html_a819e566cc3c4586f5a2c095983fa52f3"><div class="ttname"><a href="classLocoStepper.html#a819e566cc3c4586f5a2c095983fa52f3">LocoStepper::step2</a></div><div class="ttdeci">void step2(uint8_t step)</div><div class="ttdef"><b>Definition:</b> <a href="LocoStepper_8cpp_source.html#l00143">LocoStepper.cpp:143</a></div></div>
<div class="ttc" id="classLocoStepper_html_ae4045493f8395d7b3dc0a8e1477b3596"><div class="ttname"><a href="classLocoStepper.html#ae4045493f8395d7b3dc0a8e1477b3596">LocoStepper::run</a></div><div class="ttdeci">boolean run()</div><div class="ttdef"><b>Definition:</b> <a href="LocoStepper_8cpp_source.html#l00072">LocoStepper.cpp:72</a></div></div>
<div class="ttc" id="classLocoStepper_html_a8be0715eaa122dc111359e9dd06168d9"><div class="ttname"><a href="classLocoStepper.html#a8be0715eaa122dc111359e9dd06168d9">LocoStepper::move</a></div><div class="ttdeci">void move(long relative)</div><div class="ttdef"><b>Definition:</b> <a href="LocoStepper_8cpp_source.html#l00063">LocoStepper.cpp:63</a></div></div>
<div class="ttc" id="classLocoStepper_html_ae5c23466938595842934a2331cfeb21e"><div class="ttname"><a href="classLocoStepper.html#ae5c23466938595842934a2331cfeb21e">LocoStepper::setSpeed</a></div><div class="ttdeci">void setSpeed(float speed)</div><div class="ttdef"><b>Definition:</b> <a href="LocoStepper_8cpp_source.html#l00129">LocoStepper.cpp:129</a></div></div>
<div class="ttc" id="classLocoStepper_html_a2716957fdca4c048fcf5ba65e89abc95"><div class="ttname"><a href="classLocoStepper.html#a2716957fdca4c048fcf5ba65e89abc95">LocoStepper::distanceToGo</a></div><div class="ttdeci">long distanceToGo()</div><div class="ttdef"><b>Definition:</b> <a href="LocoStepper_8cpp_source.html#l00108">LocoStepper.cpp:108</a></div></div>
<div class="ttc" id="classLocoStepper_html_ae0792a7479f1a52018d948c22600fab0"><div class="ttname"><a href="classLocoStepper.html#ae0792a7479f1a52018d948c22600fab0">LocoStepper::moveTo</a></div><div class="ttdeci">void moveTo(long absolute)</div><div class="ttdef"><b>Definition:</b> <a href="LocoStepper_8cpp_source.html#l00049">LocoStepper.cpp:49</a></div></div>
<div class="ttc" id="classLocoStepper_html_a75ea615634b59ab0880cad22f7b40c48"><div class="ttname"><a href="classLocoStepper.html#a75ea615634b59ab0880cad22f7b40c48">LocoStepper::speed</a></div><div class="ttdeci">float speed()</div><div class="ttdef"><b>Definition:</b> <a href="LocoStepper_8cpp_source.html#l00135">LocoStepper.cpp:135</a></div></div>
<div class="ttc" id="classLocoStepper_html_a10a8e0c2464a99df13ff50f675e7b4e0"><div class="ttname"><a href="classLocoStepper.html#a10a8e0c2464a99df13ff50f675e7b4e0">LocoStepper::enableOutputs</a></div><div class="ttdeci">void enableOutputs()</div><div class="ttdef"><b>Definition:</b> <a href="LocoStepper_8cpp_source.html#l00191">LocoStepper.cpp:191</a></div></div>
<div class="ttc" id="classLocoStepper_html"><div class="ttname"><a href="classLocoStepper.html">LocoStepper</a></div><div class="ttdoc">Support for stepper motors with acceleration etc. </div><div class="ttdef"><b>Definition:</b> <a href="LocoStepper_8h_source.html#l00081">LocoStepper.h:81</a></div></div>
<div class="ttc" id="classLocoStepper_html_abefb91b8c07a88e6f5026e0805acdf74"><div class="ttname"><a href="classLocoStepper.html#abefb91b8c07a88e6f5026e0805acdf74">LocoStepper::LocoStepper</a></div><div class="ttdeci">LocoStepper(uint8_t pin1, uint8_t pin2, uint8_t *inpStep2 = NULL)</div><div class="ttdef"><b>Definition:</b> <a href="LocoStepper_8cpp_source.html#l00021">LocoStepper.cpp:21</a></div></div>
<div class="ttc" id="LocoStepper_8h_html"><div class="ttname"><a href="LocoStepper_8h.html">LocoStepper.h</a></div></div>
<div class="ttc" id="classLocoStepper_html_ad542ef50f02428220ab20af161e5a541"><div class="ttname"><a href="classLocoStepper.html#ad542ef50f02428220ab20af161e5a541">LocoStepper::setMinPulseWidth</a></div><div class="ttdeci">void setMinPulseWidth(unsigned int minWidth)</div><div class="ttdef"><b>Definition:</b> <a href="LocoStepper_8cpp_source.html#l00201">LocoStepper.cpp:201</a></div></div>
<div class="ttc" id="classLocoStepper_html_a92a8648eb49926cdb11f96cdc6de17b4"><div class="ttname"><a href="classLocoStepper.html#a92a8648eb49926cdb11f96cdc6de17b4">LocoStepper::targetPosition</a></div><div class="ttdeci">long targetPosition()</div><div class="ttdef"><b>Definition:</b> <a href="LocoStepper_8cpp_source.html#l00113">LocoStepper.cpp:113</a></div></div>
<div class="ttc" id="Accessories_8h_html"><div class="ttname"><a href="Accessories_8h.html">Accessories.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d41d8cd98f00b204e9800998ecf8427e.html">src</a></li><li class="navelem"><b>LocoStepper.cpp</b></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:44:46 for Accessories &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
